#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

struct vec {
    ld x, y;
    vec operator-(vec a) const {
        return {x - a.x, y - a.y};
    }
};

vec rev(vec a) {
    return {a.y, -a.x};
}

struct line {
    ld a, b, c;
};

line get(vec a, vec b) {
    return {a.y - b.y, b.x - a.x, a.x * b.y - a.y * b.x};
}

vec per(line l1, line l2) {
    ld a1 = l1.a, b1 = l1.b, c1 = l1.c;
    ld a2 = l2.a, b2 = l2.b, c2 = l2.c;
    ld x = (c1 * b2 - b1 * c2) / (a2 * b1 - a1 * b2);
    ld y = (a2 * c1 - a1 * c2) / (a1 * b2 - a2 * b1);
    return {x, y};
}

ld dist(vec a, vec b) {
    return hypotl(a.x - b.x, a.y - b.y);
}

ld d2(vec a, vec b, vec v) {
    vec v2 = rev(v);
    vec p = {a.x + v.x, a.y + v.y};
    line l1 = get(a, p);
    p = {b.x + v2.x, b.y + v2.y};
    line l2 = get(b, p);
    p = per(l1, l2);
    return dist(a, p) + dist(b, p);
}

void solve() {
    ll n;
    cin >> n;
    vector<vec> a(n);
    vector<int> nw(n);
    ll f = 1;
    for (int i = 0; i < n; i++) {
        f *= (i + 1);
        nw[i] = i;
        cin >> a[i].x >> a[i].y;
    }
    ld ans = 1e18;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            vec v = a[j] - a[i];
            for (int t = 0; t < f; t++) {
                ld cnt = 0;
                for (int k = 1; k < n; k++) {
                    ll fir = nw[k - 1], sec = nw[k];
                    cnt += d2(a[fir], a[sec], v);
                }
                ans = min(ans, cnt);
                next_permutation(nw.begin(), nw.end());
            }
        }
    }
    cout << fixed << setprecision(6) << ans;
}
