#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

struct vec {
    ld x, y;
    vec operator-(vec a) const {
        return {x - a.x, y - a.y};
    }
};

vec rev(vec a) {
    return {a.y, -a.x};
}

struct line {
    ld a, b, c;
};

line get(vec a, vec b) {
    return {a.y - b.y, b.x - a.x, a.x * b.y - a.y * b.x};
}

vec per(line l1, line l2) {
    ld a1 = l1.a, b1 = l1.b, c1 = l1.c;
    ld a2 = l2.a, b2 = l2.b, c2 = l2.c;
    ld x = (c1 * b2 - b1 * c2) / (a2 * b1 - a1 * b2);
    ld y = (a2 * c1 - a1 * c2) / (a1 * b2 - a2 * b1);
    return {x, y};
}

ld dist(vec a, vec b) {
    return hypotl(a.x - b.x, a.y - b.y);
}

ld d2(vec a, vec b, vec v) {
    vec v2 = rev(v);
    vec p = {a.x + v.x, a.y + v.y};
    line l1 = get(a, p);
    p = {b.x + v2.x, b.y + v2.y};
    line l2 = get(b, p);
    p = per(l1, l2);
    return dist(a, p) + dist(b, p);
}

void solve() {
    ll n;
    cin >> n;
    vector<vec> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    ld ans = 1e18;
    for (int i1 = 0; i1 < n; i1++) {
        for (int j1 = i1 + 1; j1 < n; j1++) {
            vec v = a[j1] - a[i1];
            vector<vector<ld>> dp((1 << n), vector<ld>(n, 1e18));
            for (int i = 0; i < n; i++) {
                dp[(1 << i)][i] = 0;
            }
            for (int mask = 0; mask < (1 << n); mask++) {
                for (int i = 0; i < n; i++) {
                    if (!((mask >> i) & 1)) {
                        continue;
                    }
                    for (int j = 0; j < n; j++) {
                        if ((mask >> j) & 1) {
                            continue;
                        }
                        int submask = mask + (1 << j);
                        dp[submask][j] = min(dp[submask][j], dp[mask][i] + d2(a[i], a[j], v));
                    }
                }
            }
            for (int i = 0; i < n; i++) {
                ans = min(ans, dp[(1 << n) - 1][i]);
            }
        }
    }
    cout << fixed << setprecision(6) << ans;
}
